--- old/usr/src/tools/smatch/src/smatch_constraints_required.c	Mon Aug  5 08:38:22 2019
+++ new/usr/src/tools/smatch/src/smatch_constraints_required.c	Mon Aug  5 08:38:22 2019
@@ -281,14 +281,17 @@
 static void match_assign_has_buf_comparison(struct expression *expr)
 {
 	struct expression *size;
+	int limit_type;
 
 	if (expr->op != '=')
 		return;
 	if (expr->right->type == EXPR_CALL)
 		return;
-	size = get_size_variable(expr->right);
+	size = get_size_variable(expr->right, &limit_type);
 	if (!size)
 		return;
+	if (limit_type != ELEM_COUNT)
+		return;
 	match_alloc_helper(expr->left, size, 1);
 }
 
@@ -455,6 +458,7 @@
 {
 	my_id = id;
 
+	set_dynamic_states(my_id);
 	add_hook(&match_assign_size, ASSIGNMENT_HOOK);
 	add_hook(&match_assign_data, ASSIGNMENT_HOOK);
 	add_hook(&match_assign_has_buf_comparison, ASSIGNMENT_HOOK);
